<?PHP

//
// Main server loop starts here
//
  $servernum = 0;
  foreach ($MyToppies as $servername)
  {
	 $servernum++ ;
   $cache = array() ;
   $use_cache[$servername] = false ;
   // Make sure the view key exists - initialise if necessary
   //if(!array_key_exists($servername,$expand_server)) { $expand_server[$servername] = is_true($TFexpandServer[$servername],"y","n") ; }
 
   if ($force_cache)  // skip the server - we'll use the cache
   {		
    $server_error[$servername] = "Forcing cache mode" ;
		echo "<!-- Forcing cache mode $servername -->\n" ;
	  $use_cache[$servername] = true ;
	  continue ;
	 }
	 
   ini_set("display_errors",0) ; 
   if(!($ftp=ftp_connect($FTPaddress[$servername],$FTPport[$servername]))) 
   {
    $server_error[$servername] = "Cannot connect to ".$FTPaddress[$servername]."" ;
	  $use_cache[$servername] = true ;
    continue ; 
   }
   if(!ftp_login($ftp,$FTPuser[$servername],$FTPpw[$servername]))
   {
    $server_error[$servername] = "Cannot login to ".$FTPaddress[$servername]."" ;
	  $use_cache[$servername] = true ;
    ftp_close($ftp) ;
    continue ; 
   }
   ftp_chdir($ftp,"/") ;
   // Now get some info about the FTP server
   $rows = array() ;
	 
   if ( version_compare(phpversion(),"5.0.0")>=0 )
   {
    $rows = ftp_raw($ftp,"STAT") ;
    foreach($rows as $key => $line)
    {
     //echo "$servername $key = $line\n" ;
	   $line = trim($line) ;
	   if(substr($line,0,3)=="500") {}  // This ftp server does not understand STAT
	   if(substr($line,0,3)=="211") {}  // This ftp server does understand STAT
	   if(substr($line,0,20)=="ftpd (Topfield ftpd)") { $FTPversion[$servername]=substr($line,21) ; }  // ftpd-topfield version
	   if(substr($line,0,9)=="HDD Free ") {}  // HDD freespace
	   if(substr($line,0,9)=="HDD Total") { $MyToppyHDD[$servername] = substr($line,10,9)*1024 ; }  // HDD total size
	   if($line == "Unable to get HDD size info" ) 
	   {
      $server_error[$servername] = $FTPaddress[$servername]." cannot connect to Topfield PVR" ;
	    $use_cache[$servername] = true ;
      ftp_close($ftp) ;
		  break ;  // break from STAT read loop
	   }
    }
	 }
	 
	 if($use_cache[$servername]) { continue ; }  // Now skip to the next server if cache is needed
	
   ini_set("display_errors",1) ; 
	 
	 
   ftp_chdir($ftp,$TFepgdata[$servername] );
   if(ftp_size($ftp,$epg_recplay)>0)
   {
  	$get = ftp_get($ftp,$epg_recplay_loc.DIRECTORY_SEPARATOR.$epg_recplay,$epg_recplay,FTP_BINARY);
  	$rows = file($epg_recplay_loc.DIRECTORY_SEPARATOR.$epg_recplay);
	  $rec1 = explode("\t",trim($rows[0])); //$rec1[1] = $data_files."/".rec1[1] ;
	  $rec2 = explode("\t",trim($rows[1])); //$rec2[1] = $data_files."/".rec2[1] ;
	  $play = explode("\t",trim($rows[2]));		
	
	  if ($rec1[1]<>"") { $cache["rec1"] = $rec1 ; $recactive = true ;}
	  if ($rec2[1]<>"") { $cache["rec2"] = $rec2 ; $recactive = true ;}
	  if ($play[1]<>"") { $cache["play"] = $play ; }		
	 }	
	 $cache["recactive"] = $recactive ;
	 
   $timers=array();
 
   ftp_chdir($ftp,$TFepgdata[$servername] );
   if(ftp_size($ftp,$epg_timers)>0)
   {
    $get = ftp_get($ftp,$epg_timers_loc.DIRECTORY_SEPARATOR.$epg_timers,$epg_timers,FTP_BINARY);
    $rows = file($epg_timers_loc.DIRECTORY_SEPARATOR.$epg_timers);
		unset($rows[0]) ; // Throw away the headings line
		//print_r($rows) ;
	
	  foreach ($rows as $index => $line)
    {
	   $line = fix_chars($line) ;
	   if(trim($line)<>"" )
	   {
	    $values = explode("\t",$line);
	    if($values[9]=="Recording" or $vcr_timers)
		  {
	     $timers[$values[3].$values[1]] = $line;
	    }
	   }
	  }
	  ksort($timers);	
		$cache["current_timers"] = $timers ;
	 //echo "There are ".count($timers)." timers currently set. (From <b>$epg_timers</b>)<br /><br />\n";	
	
	// Now build the pending timers list
  ftp_chdir($ftp,$TFepgdata[$servername] );
	
	 $add_count = 0;
	 $del_count = 0;
	 $types = array() ;
 
	if(ftp_size($ftp,$set_timers_tgd)>0)
	{
	 $get = ftp_get($ftp,$set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd,$set_timers_tgd,FTP_BINARY);
 	 $pending_timers = file($set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd);
	
	  foreach ($pending_timers as $index => $line)
	  {
	 	 $values = explode("\t",$line);
	 	 if(substr($values[7],0,1)=="D")
		 {
		 	$types[$index] = "Delete";
			$del_count++;
		 }
		 else
		 {
		 	$types[$index] = "Add";
			$add_count++;
		 }
	  }
	  //$pend_status = "$del_count deletions and $add_count additions pending" ;
   }	
	 else
	 {
	  $types = $pending_timers = array();
	  $pend_status = "There are no pending timers" ;
	 }   
	 $cache["pend_timers"] = $pending_timers ;
	 $cache["pend_types"]  = $types ;
	 // Pending timers list is built   
	 $server_cache[$servername] = $cache ;
	}
  ftp_quit($ftp) ;  // close the server connection
	
	// Save the cache file if enabled
	if($cache_enabled) { $i = file_put_contents($local_files.DIRECTORY_SEPARATOR.$servername."_timers_cache",serialize($cache)) ; }
 } //end of server data fetch 
	 
	 

?>
