/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

var unlocked = true ;
var save_class, savetable_class, save_server_class, save_servertable_class ;

function files_init() {
 if (document.getElementById("fw_count").value == 0)
 {
	 document.getElementById("fw_button").style.visibility = "hidden" ;
 }
 //document.getElementById("div_forcewin").style.visibility = "visible";
 document.getElementById("div_forcewin").style.visibility = "hidden";
}

function click_delete(theForm,filename,file_extn,directory,server) {
 theForm.set_action.value = "Delete" ;
 theForm.set_filename.value = filename + file_extn ;
 theForm.set_directory.value = directory ;
 theForm.set_server.value = server ;
 if(window.confirm("Do you really want to delete "+filename+file_extn)) { theForm.submit(); }
}

function click_rename(servernum, filename,file_extn,directory,server) {
 theForm=document.getElementById("form_rename_"+servernum);
 theForm.set_newname.value = filename ;
 theForm.set_filename.value = filename+file_extn ;
 theForm.set_directory.value = directory ;
 theForm.set_server.value = server ;
 forcewin(theForm) ;
 document.getElementById("div_servername_"+servernum).firstChild.nodeValue = server;
 document.getElementById("div_oldname_"+servernum).firstChild.nodeValue = filename+file_extn;
 document.getElementById("div_rename_"+servernum).style.visibility = "visible";
}

function click_actionrename(theForm) {
 theForm.set_action.value = "Rename" ;
 if(window.confirm("Do you really want to rename/move "+theForm.set_filename.value)) 
 {
  theForm.set_newname.value = theForm.set_newname.value + ".rec" ;
  //theForm.set_filename.value = theForm.set_filename.value + ".rec" ;
  theForm.submit(); 
 }
}

function click_forcewin() {
 document.getElementById("div_forcewin").style.visibility = "visible";
 document.getElementById("div_forcewin").style.display = "block";
}

function click_actionforcewin(theForm) {
 theForm.set_action.value = "ForceWin" ;
 if(window.confirm("Do you really want to rename these files?")) 
 {
  theForm.submit(); 
 }
}

function click_refresh(theForm) {
 theForm.set_action.value = "Refresh" ;
 theForm.submit();
}

function click_home(theForm,filename,directory) {
 theForm.set_action.value = "Home" ;
 theForm.set_filename.value = filename ;
 theForm.set_directory.value = directory;
 theForm.submit();
}

function click_sort(sort_key) {
 SetCookie("sort_key",sort_key) ;
 theForm = document.getElementById("form_files") ;
 theForm.set_file_sort.value = sort_key ;
 theForm.submit();
}


function highlight_file(theFile,servernum,foldernum,filenum) {
 save_class = theFile.className ;
 savetable_class = document.getElementById("div_extdesc_" + servernum + "_" + foldernum + "_" + filenum).className ;
 if(unlocked) 
 {
  theFile.className = "file_row_over" ; 
  document.getElementById("row_extdesc_" + servernum + "_" + foldernum + "_" + filenum).className = "file_row_over" ;
  document.getElementById("div_extdesc_" + servernum + "_" + foldernum + "_" + filenum).className = "div_extended_over" ;
 }
 return;
}

function lowlight_file(theFile,servernum,foldernum,filenum) {
 if(unlocked) 
 {
  theFile.className = save_class ; 
  document.getElementById("row_extdesc_" + servernum + "_" + foldernum + "_" + filenum).className = save_class ;
  document.getElementById("div_extdesc_" + servernum + "_" + foldernum + "_" + filenum).className = savetable_class ;
 }
}

function click_file(theFile,servernum,foldernum,filenum,filename) { 
 var theForm ;

 if (document.getElementById("div_extdesc_" + servernum + "_"  +foldernum + "_" + filenum).style.display=="block")
 {
   document.getElementById("div_extdesc_" + servernum + "_" + foldernum + "_" + filenum).style.display = "none" ;
   document.getElementById("img_file_" + servernum + "_" + foldernum + "_" + filenum).src = closedImage.src ;
   SetCookie("files_expand_file[" + filename + "]", "n") ;
 }
 else
 {
   document.getElementById("div_extdesc_" + servernum + "_" + foldernum + "_" + filenum).style.display = "block" ;
   document.getElementById("img_file_" + servernum + "_" + foldernum + "_" + filenum).src = openImage.src ;
   SetCookie("files_expand_file[" + filename + "]", "y") ;
 }
 return ;
}


function highlight_folder(theFolder,servernum,foldernum) {
 save_class = theFolder.className ;
 savetable_class = document.getElementById("table_folder_" + servernum + "_" + foldernum).className ;
 if(unlocked) 
 {
  theFolder.className = "directory_row_over" ; 
  document.getElementById("table_folder_" + servernum + "_" + foldernum).className = "table_folder_over" ;
 }
 return;
}

function lowlight_folder(theFolder,servernum,foldernum) {
 if(unlocked) 
 {
  theFolder.className = save_class ; 
  document.getElementById("table_folder_" + servernum + "_" + foldernum).className = savetable_class ;
 }
}

function click_folder(theFolder,servernum,foldernum,servername) { 
 var theForm ;
 //return ;  // temporary do nothing

 if (document.getElementById("div_folder_" + servernum + "_"  +foldernum).style.display=="block")
 {
   document.getElementById("div_folder_" + servernum + "_" + foldernum).style.display = "none" ;
   document.getElementById("img_folder_" + servernum + "_" + foldernum).src = closedImage.src ;
   save_expand(servername,foldernum,"n") ;
 }
 else
 {
   document.getElementById("div_folder_" + servernum + "_" + foldernum).style.display = "block" ;
   document.getElementById("img_folder_" + servernum + "_" + foldernum).src = openImage.src ;
   save_expand(servername,foldernum,"y") ;
 }
 return ;
}


function highlight_server(theServer,servernum) {
 save_server_class = theServer.className ;
 save_servertable_class = document.getElementById("table_server_" + servernum).className ;
 if(unlocked) 
 {
  theServer.className = "server_row_over" ; 
  document.getElementById("table_server_" + servernum).className = "table_server_over" ;
 }
}


function lowlight_server(theServer,servernum) {
 if(unlocked) 
  {
	theServer.className = save_server_class ; 
    document.getElementById("table_server_" + servernum).className = save_servertable_class ;
  }
}

function click_server(theServer,servernum,servername) { 
 var theForm ;

 if (document.getElementById("div_server_" + servernum).style.display=="block")
 {
   document.getElementById("div_server_" + servernum).style.display = "none" ;
   document.getElementById("img_server_" + servernum).src = closedImage.src ;
   save_expand(servername,0,"n") ;
 }
 else
 {
   document.getElementById("div_server_" + servernum).style.display = "block" ;
   document.getElementById("img_server_" + servernum).src = openImage.src ;
   save_expand(servername,0,"y") ;
 }
 return ;
}

function save_expand(servername,foldernum,val) {
  var theCookie ;
  theCookie = GetCookie("files_expand_server[" + servername + "]") ;
  theCookie = theCookie.substr(0, foldernum) + val + theCookie.substr(foldernum + 1);
  SetCookie("files_expand_server[" + servername + "]", theCookie) ;
  return ;
}

function forcewin(theForm) {
 var x, y ;
 if(theForm.forcewinname.checked) {
  x = theForm.set_newname.value ;
  y = x ;
  y = y.replace( /[^A-Za-z0-9.{}()%$@~!+=&,;\'\^\[\]\#\- _]/g , " ") ;
  y = y.replace( /\s+/g , " ") ;
  if (x != y) { theForm.set_newname.value = Trim(y) ; }
 }
}

function Trim(STRING){
STRING = LTrim(STRING);
return RTrim(STRING);
}

function RTrim(STRING){
while(STRING.charAt((STRING.length -1))==" "){
STRING = STRING.substring(0,STRING.length-1);
}
return STRING;
}


function LTrim(STRING){
while(STRING.charAt(0)==" "){
STRING = STRING.replace(STRING.charAt(0),"");
}
return STRING;
}